%{?!python:%define python python}
%{?!pybasever:%{expand:%%define pybasever %(%{__python} -c "import sys ; print sys.version[:3]")}}
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define origname Mantissa

Name:           %{python}-mantissa
Version:        0.4.1
Release:        4%{?dist}
Summary:        Divmod's application server

Group:          Development/Libraries
License:        MIT
URL:            http://www.divmod.org/trac/wiki/DivmodMantissa
Source0:        http://divmod.org/trac/attachment/wiki/SoftwareReleases/%{origname}-%{version}.tar.gz?format=raw

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  %{python}-twisted-core >= 2.1.1
BuildRequires:  %{python}-epsilon >= 0.4.0

# for FC3 and earlier
%if "%{pybasever}" < "2.4"
Requires:       python(abi) = %{pybasever}
%endif

Requires:       %{python}-twisted-core >= 2.1.1
Requires:       %{python}-epsilon >= 0.4.0
Requires:       %{python}-axiom >= 0.4.0
Requires:       %{python}-nevow >= 0.4.0
Requires:       %{python}-vertex >= 0.1
Requires:       pytz

# required by plugins
Requires:       %{python}-twisted-mail
Requires:       %{python}-twisted-conch

Requires(post):   %{_libexecdir}/twisted-dropin-cache
Requires(postun): %{_libexecdir}/twisted-dropin-cache

# for the postun to execute properly, axiom and nevow need to be removed after
Requires(postun): %{python}-axiom
Requires(postun): %{python}-nevow
Requires(postun): %{python}-epsilon

%description
The goal of Mantissa is to provide a common platform that open-source
contributors can use to help us build customized additions to the Divmod
service. Divmod is going to offer a variety of different services (starting
with ClickChronicle), and if you want to write something that hooks into our
network, Mantissa is how you do it.

%prep
%setup -n %{origname}-%{version} -q

%build

%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --root $RPM_BUILD_ROOT

# so we can ghost it
touch $RPM_BUILD_ROOT%{python_sitelib}/xmantissa/plugins/dropin.cache

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{_libexecdir}/twisted-dropin-cache axiom.plugins nevow.plugins xmantissa.plugins

%postun
# xmantissa.plugins is now gone
if test ! -e %{_libexecdir}/twisted-dropin-cache
then
  echo "A bug in RPM causes this package to be removed after the package"
  echo "providing twisted-dropin-cache.  Not rebuilding cache."
else
  %{_libexecdir}/twisted-dropin-cache axiom.plugins nevow.plugins
fi

%files
%defattr(-,root,root,-)
%doc NAME.txt

%{python_sitelib}/axiom/plugins/*.py
%{python_sitelib}/axiom/plugins/*.pyc
%ghost %{python_sitelib}/axiom/plugins/*.pyo
%{python_sitelib}/axiom/plugins/template.txt

%{python_sitelib}/nevow/plugins/*.py
%{python_sitelib}/nevow/plugins/*.pyc
%ghost %{python_sitelib}/nevow/plugins/*.pyo

%dir %{python_sitelib}/xmantissa/
%{python_sitelib}/xmantissa/*.py
%{python_sitelib}/xmantissa/*.pyc
%ghost %{python_sitelib}/xmantissa/*.pyo
%{python_sitelib}/xmantissa/signup.rfc2822

%dir %{python_sitelib}/xmantissa/plugins/
%{python_sitelib}/xmantissa/plugins/*.py
%{python_sitelib}/xmantissa/plugins/*.pyc
%ghost %{python_sitelib}/xmantissa/plugins/*.pyo
%ghost %{python_sitelib}/xmantissa/plugins/dropin.cache

%dir %{python_sitelib}/xmantissa/static/
%{python_sitelib}/xmantissa/static/*.css

%dir %{python_sitelib}/xmantissa/static/images/
%{python_sitelib}/xmantissa/static/images/*.png

%dir %{python_sitelib}/xmantissa/static/js/
%{python_sitelib}/xmantissa/static/js/*.js

%dir %{python_sitelib}/xmantissa/test/
%{python_sitelib}/xmantissa/test/*.py
%{python_sitelib}/xmantissa/test/*.pyc
%ghost %{python_sitelib}/xmantissa/test/*.pyo
%{python_sitelib}/xmantissa/test/*.js
%{python_sitelib}/xmantissa/test/livetest-static/

%dir %{python_sitelib}/xmantissa/themes/base
%{python_sitelib}/xmantissa/themes/base/*.html

%changelog
* Fri Jun 09 2006 Thomas Vander Stichele <thomas at apestaart dot org>
- 0.4.1-4
- added python-epsilon to postun requires, because it's needed for Version

* Fri Jun 09 2006 Thomas Vander Stichele <thomas at apestaart dot org>
- 0.4.1-3
- require and use twisted-rebuild-cache in post/postun
- add a warning about the rpm bug we run into during removal

* Fri Jun 09 2006 Thomas Vander Stichele <thomas at apestaart dot org>
- 0.4.1-2
- add post/postun python scripts to regenerate dropin.cache and ghost it
- add -mail and -conch as required by plugins

* Thu Jun 08 2006 Thomas Vander Stichele <thomas at apestaart dot org>
- 0.4.1-1
- initial package
